<template>
  <div class="template">
    <div v-if="status == 'login'">
      <h1>
        <font-awesome-icon icon="clock-rotate-left" />
        Les posts les plus récents
      </h1>
      <div class="TrendsCardElements">
        <TrendsCard v-for="(trend, index) in trends" :trend="trend" :key="index" />
      </div>
      <h1>
        <font-awesome-icon icon="reply-all" />
        Tous les posts
      </h1>
      <div class="singlePostConatiner">
        <div v-if="postloading">Chargement en cours ...</div>
        <SinglePost
          v-else
          v-for="(post, index) in posts"
          :post="post"
          :key="index"
          :deletePost="deletePost"
        />
      </div>
    </div>
    <div v-else>Veuiller vous connecter ou créer un compte pour acceder au contenu</div>
  </div>
</template>

<script>
import TrendsCard from "@/components/TrendsCard.vue";
import SinglePost from "@/components/SinglePost.vue";
import axios from "axios";
import { mapState } from "vuex";

export default {
  name: "HomeView",
  components: {
    TrendsCard,
    SinglePost,
  },
  data() {
    return {
      postloading: true,
      posts: [],
      comments: [],
      trendsNumber: 5,
    };
  },
  computed: {
    ...mapState(["status"]),
    trends() {
      const clonePosts = [...this.posts];
      return clonePosts.slice(0, this.trendsNumber);
    },
  },
  methods: {
    deletePost(postId) {
      const token = this.$store.state.user.token;
      const id = postId;
      if (
        window.confirm(
          "Voulez-vous supprimez ce post ? Cette opération est irreversible. Les commentaires seront supprimés"
        )
      ) {
        axios
          .delete(`http://localhost:3000/api/posts/delete/${id}`, {
            headers: {
              Authorization: `Basic ${token}`,
            },
          })
          .then(({ data }) => {
            this.posts = data.posts;
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
  },

  created() {
    axios
      .get("http://localhost:3000/api/posts")
      .then((response) => {
        this.posts = response.data;
        this.postloading = false;
      })
      .catch((error) => {
        console.log(error);
      });
  },
};
</script>

<style lang="scss" scoped>
h1 {
  color: grey;
  font-weight: normal;
  font-style: italic;
}
.TrendsCardElements {
  display: flex;
  justify-content: space-around;
  flex-wrap: wrap;
}
@media screen and (max-width: 660px) {
  .template {
    padding-top: 150px;
  }
  .TrendsCardElements {
    flex-direction: column;
  }
}
</style>
